----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    08:52:48 04/02/2012 
-- Design Name: 
-- Module Name:    FTDI - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
--use Work.Global.ALL;
use Global.ALL;
--********************************************************************************
--********************************************************************************
--********************************************************************************
entity FTDI is Port ( 
  CLK:          in STD_LOGIC;                    -- Clock Eingang
  RST:          in STD_LOGIC;                    -- Reset von PCB

  -- Interface zum FTDI-Chip
  ChipStatus:   in TFTDIChipStat;
  ChipCtrl:    out TFTDIChipCtrl;

  -- Interface zum Main-Controller
  MainStatus:  out TFTDIMainStat;
  MainCtrl:     in TFTDIMainCtrl);

end FTDI;
--///////////////////////////////////////////////////////////////////
architecture Behavioral of FTDI is
  type TFTDIStat is (IDLE, WAIT_TXE, WR_DATA, WR_DONE);
  ---------------------------------------------------------
  signal FSMStat: TFTDIStat;
  ---------------------------------------------------------
begin
  P1: process(RST, CLK, MainCtrl, ChipStatus)
    variable ByteCNT: STD_LOGIC_VECTOR(11 downto 0);
  begin
    if RST = '0' then
      ByteCnt := (others => '0');
      FSMStat <= IDLE;
    elsif rising_edge(CLK) then
      case FSMStat is
        when IDLE     => ByteCNT := (others => '0'); 
                         if MainCtrl.STA = '0' then
                           FSMStat <= WAIT_TXE;
                         end if;
        when WAIT_TXE => if ChipStatus.TXE = '0' then
                           FSMStat <= WR_DATA;
                         end if;
        when WR_DATA  => if ChipStatus.TXE = '1' then
                           ByteCNT := ByteCNT - 1;
                           FSMStat <= WAIT_TXE;
                         else
                           ByteCNT := ByteCNT + 1;
                           if (ByteCNT = x"800" - 1) then 
                             FSMStat <= WR_DONE;
                           end if;
                         end if;
        when WR_DONE  => ByteCNT := x"AAA";
                         FSMStat <= IDLE;
      end case;
    end if;
  end process;

  with FSMStat select ChipCtrl.WR    <= ChipStatus.TXE when WR_DATA, '1' when others;
  --ChipCtrl.WR <= ChipStatus.TXE when FSMStat = WR_DATA else '1';
  with FSMStat select MainStatus.RDY <=            '1' when WR_DATA, '0' when others;
  
  ChipCtrl.RD <= '1';
  ChipCtrl.OE <= '1';
  
  
end Behavioral;
--********************************************************************************
--********************************************************************************
--********************************************************************************

